
home = pwd;

path(path,pwd);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cd ('../data');

fid = fopen('http-seed3-psm0-bp100-sa0-li_null-pct0-max8-bs20ms-pagetime.dat', 'r');
[nopsm_pagetimes, c] = fscanf(fid,'%f'); 
fclose(fid);

fid = fopen('http-seed3-psm1-bp100-sa0-li_null-pct0-max8-bs20ms-pagetime.dat', 'r');
[psm_sa0_pagetimes, c] = fscanf(fid,'%f'); 
fclose(fid);

fid = fopen('http-seed3-psm1-bp100-sa1.0-li_percent-pct10-max8-bs20ms-pagetime.dat', 'r');
[psm_10pct_pagetimes, c] = fscanf(fid,'%f'); 
fclose(fid);

fid = fopen('http-seed3-psm1-bp100-sa0.5-li_percent-pct20-max8-bs20ms-pagetime.dat', 'r');
[psm_20pct_pagetimes, c] = fscanf(fid,'%f'); 
fclose(fid);

fid = fopen('http-seed3-psm1-bp100-sa0.2-li_percent-pct50-max8-bs20ms-pagetime.dat', 'r');
[psm_50pct_pagetimes, c] = fscanf(fid,'%f'); 
fclose(fid);

fid = fopen('http-seed3-psm1-bp100-sa0.1-li_percent-pct100-max8-bs20ms-pagetime.dat', 'r');
[psm_100pct_pagetimes, c] = fscanf(fid,'%f'); 
fclose(fid);


cd(home);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



psm_sa0_slowdown_mean = mean(psm_sa0_pagetimes ./ nopsm_pagetimes);
psm_100pct_slowdown_mean = mean(psm_100pct_pagetimes ./ nopsm_pagetimes);
psm_50pct_slowdown_mean = mean(psm_50pct_pagetimes ./ nopsm_pagetimes);
psm_20pct_slowdown_mean = mean(psm_20pct_pagetimes ./ nopsm_pagetimes);
psm_10pct_slowdown_mean = mean(psm_10pct_pagetimes ./ nopsm_pagetimes);

slowdown_means = [ 1 ...
		     psm_sa0_slowdown_mean ...
		     psm_100pct_slowdown_mean ...
		     psm_50pct_slowdown_mean ...
		     psm_20pct_slowdown_mean ...
		     psm_10pct_slowdown_mean ];



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

					 
%% figure;
%% hold;
%% bar(slowdown_means);
%% set(gca,'ylim',[1 3]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


pagetimes = [nopsm_pagetimes psm_sa0_pagetimes psm_100pct_pagetimes psm_10pct_pagetimes];

sortedpagetimes = sortrows(pagetimes);
sortedpagetimes_subset = sortrows(pagetimes(1:1000,:));


% figure;
% hold;
% plot(nopsm_pagetime,psm_pagetime,'b.');
% plot(nopsm_pagetime,psm_sa_pagetime,'r.');
% plot([0:3000]/10, [0:3000]/10);
% set(gca,'yscale','log');
% set(gca,'xscale','log');


% figure;
% hold;
% plot(sortedpagetimes(:,1),'b');
% plot(sortedpagetimes(:,2),'r');
% plot(sortedpagetimes(:,3),'g');
% set(gca,'yscale','log');


% figure;
% hold;
% plot(sortedpagetimes(:,1), sortedpagetimes(:,2) ./ sortedpagetimes(:,1),'ro','markersize',2);
% plot(sortedpagetimes(:,1), sortedpagetimes(:,3) ./ sortedpagetimes(:,1),'bo','markersize',2);
% plot(sortedpagetimes(:,1), sortedpagetimes(:,4) ./ sortedpagetimes(:,1),'go','markersize',2);
% plot(mean(sortedpagetimes(:,1)), mean(sortedpagetimes(:,2) ./ sortedpagetimes(:,1)), ...
%      'ko', 'markersize', 20,'linewidth',3,'MarkerFaceColor','r');
% plot(mean(sortedpagetimes(:,1)), mean(sortedpagetimes(:,3) ./ sortedpagetimes(:,1)), ...
%      'ko', 'markersize', 20,'linewidth',3,'MarkerFaceColor','b');
% plot(mean(sortedpagetimes(:,1)), mean(sortedpagetimes(:,4) ./ sortedpagetimes(:,1)), ...
%      'ko', 'markersize', 20,'linewidth',3,'MarkerFaceColor','g');
% set(gca,'xscale','log');
% set(gca,'xlim',[0.1 100]);
% set(gca,'xtick',[0.1 1 10 100]);
% set(gca,'xticklabel',{'0.1s' '1s' '10s' '100s'});
% set(gca,'ylim',[1 2.6]);
% set(gca,'fontsize',18);
% xlabel('page retrieval time (no PSM)','fontsize',18);
% ylabel('PSM slowdown','fontsize',18);
% legend('PSM basic', 'PSM 100%', 'PSM 10%', 'PSM basic mean', 'PSM 100% mean', 'PSM 10% mean',1);




% figure;
% hold;
% plot(sortedpagetimes_subset(:,1), sortedpagetimes_subset(:,2) ./ sortedpagetimes_subset(:,1),...
%      'o','markersize',6,'color',[.4 .4 .4]);
% plot(sortedpagetimes_subset(:,1), sortedpagetimes_subset(:,3) ./ sortedpagetimes_subset(:,1),...
%      's','markersize',6,'color',[ 0  0  0]);
% plot(sortedpagetimes_subset(:,1), sortedpagetimes_subset(:,4) ./ sortedpagetimes_subset(:,1),...
%      '^','markersize',6,'color',[.8 .8 .8]);
% plot(mean(sortedpagetimes(:,1)), mean(sortedpagetimes(:,2) ./ sortedpagetimes(:,1)), ...
%      'ko', 'markersize', 20,'linewidth',1,'MarkerFaceColor',[.4 .4 .4]);
% plot(mean(sortedpagetimes(:,1)), mean(sortedpagetimes(:,3) ./ sortedpagetimes(:,1)), ...
%      'ws', 'markersize', 20,'linewidth',1,'MarkerFaceColor',[ 0  0  0]);
% plot(mean(sortedpagetimes(:,1)), mean(sortedpagetimes(:,4) ./ sortedpagetimes(:,1)), ...
%      'k^', 'markersize', 20,'linewidth',1,'MarkerFaceColor',[.8 .8 .8]);
% set(gca,'xscale','log');
% set(gca,'xlim',[0.1 100]);
% set(gca,'xtick',[0.1 1 10 100]);
% set(gca,'xticklabel',{'0.1s' '1s' '10s' '100s'});
% set(gca,'ylim',[1 2.6]);
% set(gca,'fontsize',16);
% xlabel('page retrieval time (no PSM)','fontsize',16);
% ylabel('PSM slowdown','fontsize',16);
% legend('PSM basic', 'PSM 100%', 'PSM 10%', 'PSM basic mean', 'PSM 100% mean', 'PSM 10% mean',1);




figure;
hold;

subplot(2,3,1);
plot(sortedpagetimes_subset(:,1), sortedpagetimes_subset(:,2) ./ sortedpagetimes_subset(:,1),'o','markersize',3);
m = mean(sortedpagetimes_subset(:,2) ./ sortedpagetimes_subset(:,1));
line([0.1 100],[m m]);
set(gca,'xscale','log');
set(gca,'xlim',[0.1 100]);
set(gca,'xtick',[0.1 1 10 100]);
set(gca,'xticklabel',{'0.1' '1' '10' '100'});
set(gca,'ylim',[1 2.6]);
set(gca,'fontsize',10);
ylabel('PSM slowdown','fontsize',10);
title('(a) PSM-basic');

subplot(2,3,2);
plot(sortedpagetimes_subset(:,1), sortedpagetimes_subset(:,3) ./ sortedpagetimes_subset(:,1),'o','markersize',3);
m = mean(sortedpagetimes_subset(:,3) ./ sortedpagetimes_subset(:,1));
line([0.1 100],[m m]);
set(gca,'xscale','log');
set(gca,'xlim',[0.1 100]);
set(gca,'xtick',[0.1 1 10 100]);
set(gca,'xticklabel',{'0.1' '1' '10' '100'});
set(gca,'ylim',[1 2.6]);
set(gca,'fontsize',10);
xlabel('page retrieval time with PSM off (seconds)','fontsize',10);
title('(b) Bounded-Slowdown-100%');

subplot(2,3,3);
plot(sortedpagetimes_subset(:,1), sortedpagetimes_subset(:,4) ./ sortedpagetimes_subset(:,1),'o','markersize',3);
m = mean(sortedpagetimes_subset(:,4) ./ sortedpagetimes_subset(:,1));
line([0.1 100],[m m]);
set(gca,'xscale','log');
set(gca,'xlim',[0.1 100]);
set(gca,'xtick',[0.1 1 10 100]);
set(gca,'xticklabel',{'0.1' '1' '10' '100'});
set(gca,'ylim',[1 2.6]);
set(gca,'fontsize',10);
title('(c) Bounded-Slowdown-10%');








