
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fid = fopen('../data/http-seed3-psm0-bp100-sa0-li_null-pct0-max8-bs20ms-reqlen.dat', 'r');
[rv_reqlen, rv_reqlen_c] = fscanf(fid,'%f'); 
fclose(fid);

fid = fopen('../data/http-seed3-psm0-bp100-sa0-li_null-pct0-max8-bs20ms-replen.dat', 'r');
[rv_replen, rv_replen_c] = fscanf(fid,'%f'); 
fclose(fid);

fid = fopen('../data/http-seed3-psm0-bp100-sa0-li_null-pct0-max8-bs20ms-imgnum.dat', 'r');
[rv_imgnum, rv_imgnum_c] = fscanf(fid,'%f'); 
fclose(fid);

fid = fopen('../data/http-seed3-psm0-bp100-sa0-li_null-pct0-max8-bs20ms-ctime.dat', 'r');
[rv_ctime, rv_ctime_c] = fscanf(fid,'%f'); 
fclose(fid);

fid = fopen('../data/http-seed3-psm0-bp100-sa0-li_null-pct0-max8-bs20ms-stime.dat', 'r');
[rv_stime, rv_stime_c] = fscanf(fid,'%f'); 
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure;
hold;

subplot(2,3,1);
plot([0:max(rv_reqlen)/10]*10, cumsum(histc(sort(rv_reqlen),[0:max(rv_reqlen)/10]*10))/rv_reqlen_c,'linewidth',3);
set(gca,'xscale','linear');
set(gca,'xlim',[0 1200]);
title('Request Length (bytes)');

subplot(2,3,2);
plot([0:max(rv_replen)/10]*10, cumsum(histc(sort(rv_replen),[0:max(rv_replen)/10]*10))/rv_replen_c,'linewidth',3);
set(gca,'xscale','log');
set(gca,'xtick',[10 100 1000 10000 100000]);
set(gca,'xlim',[10 100000]);
title('Response Length (bytes)');

subplot(2,3,3);
plot([0:100], cumsum(histc(sort(rv_imgnum),[0:100]))/rv_imgnum_c,'linewidth',3);
set(gca,'xscale','linear');
set(gca,'ylim',[0 1]);
set(gca,'xlim',[0 20]);
title('Number of Images');

subplot(2,3,4);
plot([1:2001]/10, cumsum(histc(sort(rv_stime),[0:2000]/10))/rv_stime_c,'linewidth',3);
set(gca,'xscale','log');
set(gca,'ylim',[0 1]);
set(gca,'xtick',[0.1 1 10 100]);
set(gca,'xlim',[0.1 200]);
title('Server Response Time (seconds)');

subplot(2,3,5);
plot([1:1001], cumsum(histc(sort(rv_ctime),[0:1000]))/rv_ctime_c,'linewidth',3);
set(gca,'xscale','log');
set(gca,'xtick',[1 10 100 1000]);
set(gca,'xlim',[1 1000]);
title('User Think Time (seconds)');












